import react from 'react'

type ProjectElementProps = {
    image_src?: string,
    description: string,
    url: string
}

function ProjectElement({ image_src, description, url }: ProjectElementProps) {
    return (
        <a href={url} target='_blank'>
            {
                image_src && <img src={image_src} />
            }
            <div><p>{description}</p></div>
        </a>
    )
}

export default ProjectElement